package ttt.gui;

import java.awt.*;
import java.awt.event.*;
import javax.swing.*;

import ttt.model.Player;
import ttt.model.TTTGame;

import java.util.*;

/** A graphical panel to hold information about the TTT players. */
public class TTTPlayersPanel extends JPanel {
    private static final long serialVersionUID = 0;
    
    // fields
    private TTTGame game;
    
    public TTTPlayersPanel(TTTGame game) {
        this.game = game;
        setLayout(new BoxLayout(this, BoxLayout.Y_AXIS));
        
        int i = 1;
        for (Iterator<Player> itr = game.getPlayerIterator(); itr.hasNext(); ) {
            Player player = itr.next();
            addPlayer(player, i++);
        }
        
        this.add(new JPanel());
    }
    
    // places another player's information onto this panel. 
    private void addPlayer(final Player player, int number) {
        JLabel headerLabel = new JLabel("<html><b><u><font size=\"+3\">Player "
                + number + "</font></u></b></html>");
        JLabel nameLabel = new JLabel("Name: ");
        final JTextField nameField = new JTextField(player.getName(), 6);
        
        nameField.addActionListener(new ActionListener() {
            public void actionPerformed(ActionEvent e) {
                String text = nameField.getText();
                player.setName(text);
            }
        });
        
        final JLabel winsLabel = new JLabel("Wins: " + player.getWins());
        game.addObserver(new Observer() {
            public void update(Observable o, Object arg) {
                winsLabel.setText("Wins: " + player.getWins());
            }
        });
        
        this.add(headerLabel);
        
        JPanel temp = new JPanel();
        temp.setBackground(Color.BLUE);
        
        temp.add(nameLabel);
        temp.add(nameField);
        this.add(temp);
        
        this.add(winsLabel);
    }
}
